PlayMIDI {
	var <score, noteons, <midifile, server;
	var <>synthdefs;
	
	*new {arg midifilepath, synthdefs, server;
	 	^super.new.init(midifilepath, synthdefs, server);
	}
	
	init {arg midifilepath, argsynthdefs, argserver;
		server = argserver ? Server.default;
		synthdefs = argsynthdefs;
		midifile = MIDIFile.new;
		midifile.readHeader(midifilepath);
		midifile.read(midifilepath);
		score = Score.new;
		// 128 noteons at one time for now
		noteons = Dictionary.new(128);
		this.makeScore;
		}
		
	makeScore {
		midifile.scores.do{arg me; 
			me.do{arg thisevent, i; 
				var times, channel, keynum, vel, abstime, node;
				#times, channel, keynum, vel, abstime = thisevent;
				((vel > 0) && (vel < 127)).if({
					// velocity non 0, note on, add to score
					score.add([abstime / midifile.division, [\s_new, synthdefs.wrapAt(i), 
						node = server.nextNodeID, 0, 0, \freq, keynum.midicps,
						// try to keep the amplitude within range 
						\amp, vel / (127 * midifile.ntrks)]]);
					// save nodeID according to keynum to Dictionary
					noteons.add(keynum.asSymbol -> node);
					}, {
					// velocity 0 or 127, note off
					noteons.at(keynum.asSymbol).notNil.if({
						score.add([abstime / midifile.division, 
							[\n_set, noteons.at(keynum.asSymbol), \gate, 0]])});
					// free the node from the dictionary
					noteons.removeAt(keynum.asSymbol)
					})
				}
			};
		score.sort;
	}
}